﻿/*******************************************************************************
File        : Program.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/05/13 TPR Created
*******************************************************************************/
using System;
using Wiker.WIDatabase;
using System.Text;

namespace DistinctCount
{
   /*******************************************************************************
   Class        : Program
   Description  : 
   --------------------------------------------------------------------------------
   History:
   2011/05/13 TPR Created
   *******************************************************************************/
   class Program
   {      
      /*******************************************************************************
      Function    : Main()
      Description : 
      Parameters  : string[] args - 
      Returns     : void
      --------------------------------------------------------------------------------
      History:
      2011/05/13 TPR Created
      *******************************************************************************/
      static void Main(string[] args)
      {         
         WIDatabase WIDB;
         CDatabaseInfo DBInfo;
         int Count;
         StringBuilder StrB;

         /* Create DatabaseInfo object with login info  */
         DBInfo = new CDatabaseInfo();
         DBInfo.DatabaseType = eDatabaseType.SQLite;
         DBInfo.Location =  "\\WIDatabase\\Samples";
         DBInfo.DBName = "SQLite.db3";         
         DBInfo.Password = "";
         DBInfo.Port = 0;
         DBInfo.Username = "";

         /* Create WIDatabase object */         
         WIDB = new WIDatabase(DBInfo);

         /* Calling Select.Clear() ensures we starting with a new select statement. */
         WIDB.Search.Clear();

         /* Select.Table: The 'Main' table from which the data will originate */
         WIDB.Search.Table("tblAddress");

         /* Return number of distinct records */
         WIDB.Search.DistinctCount("Count","ZipCode");
         
         /* Select.Execute() prepares the statement to be sent to the Database */         
         if (!WIDB.Search.Execute())
            {
            Console.WriteLine(string.Format("Failed To Search Table\n{0} - {1}", WIDB.LastError.ToString(), WIDB.LastErrorMessage));
            return;
            }

         /* Select.Read() reads the next row from the returned data */
         while (WIDB.Search.Read())
            {
            StrB = new StringBuilder();
            
            /* Select.Get obtains the value of the named column via an out parameter */
            WIDB.Search.Get("Count",out Count);
            StrB.AppendFormat("| {0} |",Count);

            Console.WriteLine(StrB.ToString());
            }

         /* Good practice is to close the DB when finished */
         WIDB.Close();
      }
   }/* End Class */
}/* End NameSpace */
